<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Datensatz ändern</title>
</head>
<body>
<?php // ********** ab hier PHP **********
// ************************************************************************************************
// Datensätze einer Tabelle ausgeben
// $_POST[] Eingabewerte:
// database: Datenbank, aus der die Tabelle kommt.
// table:    Tabelle, aus der ein Datensatz geändert wird
// where:    Bedingung hinter WHERE, die den Datensatz eindeutig beschreibt
// ************************************************************************************************
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// ************************************************************************************************
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Datenbanknamen und Tabelle festlegen, falls nicht per POST übergeben
if (empty($database)) $database=$username."_bibliothek";
if (empty($table)) $table="Benutzer";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung zum Server prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
// Zeichensatz utf-8 für die Verbindung zum Server einstellen
$conn->set_charset('utf8');
// Datenbanknamen und Tabelle und Bedingung prüfen
if (empty($database) || empty($table) || empty($where)) die("Datenbank, Tabelle oder Datensatz nicht festgelegt.");
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// Datensatz aus der Tabelle auslesen
$sql = "SELECT * FROM $table WHERE $where;";
echo "<p>Tabelle $table, SQL-Befehl: $sql</p>";
$result = $conn->query($sql);
// ************************************************************************************************
// Eingabemaske anzeigen
// ************************************************************************************************
if ($result->num_rows > 0) {
    // Der Datensatz wurde korrekt gelesen: FORM und HTML-Tabelle vorbereiten
    // die form umschließt alles
    echo "<form action='db-edit-change.php' method='post'>\n";
    // In der Tabelle werden alle Eingabefelder systematisch dargestellt
    echo "<table style='background-color: #CCCCCC; border: 1px solid black;'>";
    // Überschrift der Tabelle
    echo "<tr><th>Eigenschaft</th><th>Wert</th></tr>";
    // Eigenschaften der Attribute ermitteln
    $sql2 = "SHOW COLUMNS FROM `aaa_bibliothek`.`$table`";
    $result2 = $conn->query($sql2);
    // Datensatz in das assoziative Array $row[] einlesen
    $row = $result->fetch_assoc();
    // Nacheinander alle Spalten/Attribute bearbeiten und Namen bzw. Inhalt darstellen
    while ($row2=$result2->fetch_assoc()) {
        $key=$row2["Field"]; // Name des Attributes
        $value=$row[$key]; // Wert des Attributes
        $datatype=$row2["Type"];
        $auto_increment=$row2["Extra"]=="auto_increment";
        // Herausfinden, ob ein $key Fremdschlüssel ist
        $sql3="SELECT * FROM information_schema.KEY_COLUMN_USAGE WHERE TABLE_SCHEMA='aaa_bibliothek' AND TABLE_NAME='$table' AND COLUMN_NAME='$key' AND CONSTRAINT_NAME!='PRIMARY';";
        $result3 = $conn->query($sql3);
        if ($result3->num_rows > 0) { // Fremdschlüssel erkannt
            $row3 = $result3->fetch_assoc(); // Namen der Mastertabelle und des Primärschlüssels holen
            $foreignTable=$row3["REFERENCED_TABLE_NAME"];
            $foreignKey  =$row3["REFERENCED_COLUMN_NAME"];
            $displayKey  =$foreignKey;
        } else {
            $foreignTable="";
        }
        // Namen in Spalte 1 darstellen
        echo "<tr><td>$key</td>";
        // Inhalt im Eingabefeld in Spalte 2 darstellen
        if ($foreignTable!="") { // Bei Fremdschlüsseln eine Mehrfachauswahl als Popup aufbauen
            $sql3 = "SELECT $foreignKey, $displayKey FROM $foreignTable ORDER BY $displayKey;";
            $result3 = $conn->query($sql3);
            if ($result3 && $result3->num_rows>0) {
                // nur darstellen, wenn wirklich Datensätze in der fremden Tabelle vorhanden sind
                // Zelle beginnen und select-Element öffnen
                echo "<td><select name='in-$key'>\n";
                // Alle Datensätze der Mastertabelle einlesen und ein Auswahlelement erzeugen
                while ($row3 = $result3->fetch_assoc()) {
                    // Der Wert des Primärschlüssels ist der Wert, der per POST übergeben wird
                    echo "<option value='".$row3[$foreignKey]."' ";
                    if ($row3[$foreignKey]==$value) echo "selected";
                    echo ">";
                    // Nun folgt der Wert, der benutzerfreundlich angezeigt wird
                    echo $row3[$displayKey]."</option>\n";
                }
                // select-Element schließnen, Zelle und Zeile beenden
                echo "</select></td></tr>\n";
            }
        }
        else if ($datatype=="datetime") { // Datum und Uhrzeit
            echo "<td><input type='datetime-local' name='in-$key' value='$value'></td></tr>\n";
        }
        else if ($datatype=="date") { // Datum
            echo "<td><input type='date' name='in-$key' value='$value'></td></tr>\n";
        }
        else { // Wenn keine Besonderheit vorliegt, ein einfaches Eingabefeld verwenden
            echo "<td><input type='text' name='in-$key' value='$value'></td></tr>\n";
        }
    }
    echo "<tr><td>&nbsp;</td><td><input type='hidden' name='database' value='$database'>\n";
    echo "<input type='hidden' name='table' value='$table'>\n";
    echo "<input type='hidden' name='where' value=\"$where\">\n";
    echo "<input type='submit' value='Ändern'>\n";
    echo "</td></tr></table>\n";
    echo "</form>\n";
}
else {
    echo "<p>Kein Datensatz vorhanden.</p>";
}
// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
?> 

<p><a href="javascript:history.back()">Zurück</a></p>
</body>
</html>